//go:generate go mod vendor
//go:generate protoc --go_out=plugins=grpc,paths=source_relative:. -I .:vendor/gitlab.mashplace.com/mashplace/backend mashroom_cardpayment.proto
//go:generate rm -r vendor
//go:generate mockgen -package=mockcardpayment -destination=mock/client.go . CardpaymentServiceClient
//go:generate go fmt ./...
//go:generate go fix ./...
//go:generate goimports -w ./
//go:generate go mod tidy

// Package cardpayment provides cardpayment service api
package cardpayment // import "gitlab.mashplace.com/mashplace/backend/cardpayment/api"

import (
	// generic proto
	_ "gitlab.mashplace.com/mashplace/backend/common/api/generic"
	_ "gitlab.mashplace.com/mashplace/backend/common/api/generic/query"
	_ "gitlab.mashplace.com/mashplace/backend/common/api/protobuf"
	_ "gitlab.mashplace.com/mashplace/backend/extras/api"
)
