package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

// Changelog entry
type Changelog struct {
	ID       primitive.ObjectID     `bson:"_id,omitempty"`
	Context  string                 `bson:"context"`
	Kind     string                 `bson:"kind"`
	Object   string                 `bson:"object"`
	Ref      string                 `bson:"ref"`
	Op       string                 `bson:"op"`
	Old      map[string]interface{} `bson:"old"`
	New      map[string]interface{} `bson:"new"`
	Metadata map[string]interface{} `bson:"metadata"`
	Created  time.Time              `bson:"created"`
}
